/************************************************************
  sit.c  By: Stephen Vermeulen

  Copyright (C) 1987 By Stephen Vermeulen

  Use this tool to set the type of an icon.

  It has the following syntax:

      sit file [type]

  when this is typed, sit will load the file called "file.info"
  and change it to the given type and then resave it under
  the old name to the disk.  The allowable types are:

       1 = DISK
       2 = DRAWER
       3 = TOOL
       4 = PROJECT
       5 = GARBAGE
       6 = DEVICE   Say what?????????????????????!!!!!!!!!!!!!!
       7 = KICK
************************************************************/

#include <intuition/intuition.h>
#include <workbench/workbench.h>
#include <stdio.h>
#include <functions.h>

#define NO_ICONS       4

extern ULONG IconBase;

/************************************************************
  The following routine just opens the libraries
************************************************************/

short OpenLibs()
{
  short flags; /* any libraries that do not open get recorded here */

  flags = 0;
  IconBase = (ULONG) OpenLibrary("icon.library", 0L);
  if (!IconBase) flags |= NO_ICONS;
  return(flags);
}

void CloseLibs(flags)
short flags;
{
  if (!(flags & NO_ICONS))     CloseLibrary(IconBase);
}

void main(argc, argv)
short argc;
char *argv[];
{
  short lib_flags, icon_type;
  struct DiskObject *dobj;

  if (argc == 3)
  {
    lib_flags  = OpenLibs();
    if (!lib_flags)
    {
      if (dobj = GetDiskObject(argv[1]))
      {
        sscanf(argv[2], "%d", &icon_type);
        if (icon_type < 1) icon_type = 1;
        if (icon_type > 7) icon_type = 7;
        dobj->do_Type = icon_type;
        PutDiskObject(argv[1], dobj);
        FreeDiskObject(dobj);
      }
    }
    CloseLibs(lib_flags);
  }
  else if (argc == 2)
  {
    lib_flags  = OpenLibs();
    if (!lib_flags)
    {
      if (dobj = GetDiskObject(argv[1]))
      {
        printf("Type %d ", dobj->do_Type);
        switch(dobj->do_Type)
        {
          case 1:
            printf("WBDISK\n");
            break;
          case 2:
            printf("WBDRAWER\n");
            break;
          case 3:
            printf("WBTOOL\n");
            break;
          case 4:
            printf("WBPROJECT\n");
            break;
          case 5:
            printf("WBGARBAGE\n");
            break;
          case 6:
            printf("WBDEVICE\n");
            break;
          case 7:
            printf("WBKICK\n");
            break;
          deafult:
            printf("UNKNOWN TYPE\n");
        }
        FreeDiskObject(dobj);
      }
    }
    CloseLibs(lib_flags);
  }
  else
  {
    printf("Syntax is: sit icon [newtype]\n");
    printf("newtype:  1 = disk     2 = drawer   3 = tool\n");
    printf("          4 = project  5 = garbage  6 = device  7 = kick\n");
    printf("This is version 1.00\n");
    printf("Written and Copyright (C) 1987 by: Stephen Vermeulen\n");
    printf("                                   3635 Utah Dr. N.W.,\n");
    printf("                                   Calgary, Alberta,\n");
    printf("                                   CANADA, T2N 4A6\n");
    printf("\n                                   (403) 282-7990\n");
    printf("\nSupport more Vware, send a donation or a bug report...\n");
    printf("This program may be freely distributed so long as no\n");
    printf("charge is made for such distribution.\n");
  }
}
